# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.4
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field
from synctera_client_v1.models.card_type import CardType
from synctera_client_v1.models.credit_card_request_details import CreditCardRequestDetails

class CreditCard(BaseModel):
    """
    A card that can spend against a credit account
    """
    card_details: CreditCardRequestDetails = Field(...)
    type: CardType = Field(...)
    __properties = ["card_details", "type"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> CreditCard:
        """Create an instance of CreditCard from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of card_details
        if self.card_details:
            _dict['card_details'] = self.card_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> CreditCard:
        """Create an instance of CreditCard from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return CreditCard.parse_obj(obj)

        _obj = CreditCard.parse_obj({
            "card_details": CreditCardRequestDetails.from_dict(obj.get("card_details")) if obj.get("card_details") is not None else None,
            "type": obj.get("type")
        })
        return _obj

