# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 1.41.4
    Contact: dev@swadesh.co
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
from inspect import getfullargspec
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr
from synctera_client_v1.models.card_type import CardType
from synctera_client_v1.models.debit_card_response_details import DebitCardResponseDetails

class DebitCardResponse(BaseModel):
    """
    A card that can spend against a deposit account
    """
    card_details: DebitCardResponseDetails = Field(...)
    tenant: StrictStr = Field(..., description="The id of the tenant containing the resource. ")
    type: CardType = Field(...)
    __properties = ["card_details", "tenant", "type"]

    class Config:
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> DebitCardResponse:
        """Create an instance of DebitCardResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of card_details
        if self.card_details:
            _dict['card_details'] = self.card_details.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> DebitCardResponse:
        """Create an instance of DebitCardResponse from a dict"""
        if obj is None:
            return None

        if type(obj) is not dict:
            return DebitCardResponse.parse_obj(obj)

        _obj = DebitCardResponse.parse_obj({
            "card_details": DebitCardResponseDetails.from_dict(obj.get("card_details")) if obj.get("card_details") is not None else None,
            "tenant": obj.get("tenant"),
            "type": obj.get("type")
        })
        return _obj

